<?php

/*

Usage:

* Declare fields below
* In your skin (member) or template --not done (comments, posts) use:
      <%Profile(field)%>
* When on its own member page, a member can edit his profile

History:
  v1.0a - Initial release
  v1.1 - use sql_table(), add supportsFeature

  todo:
  - rewrite:
    - using MemberOption
    - admin customize fields??
*/


class NP_Profile extends NucleusPlugin {

   var $field;
   var $default;

   function getName() {
      return 'Profile Plugin';
   }
   
   function getAuthor()  {
      return 'Tim Broddin | Edmond Hui (admun)';
   }
   
   function getURL()   {
      return 'http://www.fuckhedz.com/';
   }
   
   function getVersion() {
      return '1.1';
   }
   
   function getDescription() {
      return 'Gives each member a customisable profile';
   }
   
   function supportsFeature($what) {
      switch($what) {
        case 'SqlTablePrefix':
          return 1;
        default:
          return 0;
      }
   }

   function install() {
      sql_query("CREATE TABLE ". sql_table(plugin_profile).
                    " ( `memberid` int(11),
                      `field` varchar(255),
                      `value` varchar(255),
                      KEY `member` (`memberid`),
                      KEY `field` (`field`))");
   }
   
   function NP_Profile() {
      // Available types: text, textarea, mail (encoded), file, list, password, dropdown, date, url, number
      //
      // Text: simple text
      // Textarea: a bigger textarea
      // Mail: provides an additional mail adress field (for example for MSN adress)
      // File: file selector (uploads to /media/{memberid}/
      // List: selection list with ability to choose multiple items
      // Password: masked text input
      // Dropdown: dropdown list
      // Date: date entry field
      // Url: text field containing an url
      //
      
      // Additional attributes
      // Text: maxlenght, size
      // Textarea: rows, cols
      // Mail: maxlenght, size
      // File: type (= array, example: $this->field[0]['type'][0] = 'jpg';), size (width of the input field),
      //       maxsize (in bytes),
      //         for images:  maxheight, maxwidth
      // Password: maxlenght, size
      // Dropdown: option (example: $this->field[0]['option'][0]) which has a name and a value
      // Date: format (possible: D-M-Y, M-D-Y, Y-M-D, Y-D-M)
      
      // You can't create fields with the following names: nick, name, realname, password, email,
      //                                                  url, notes, action, type, submit
      // These fields are already provided by the plugin.
      
      $this->default['text']['maxlenght'] = 255;
      $this->default['text']['size'] = 40;
      $this->default['textarea']['rows'] = 4;
      $this->default['textarea']['cols'] = 25;
      $this->default['mail']['maxlenght'] = 60;
      $this->default['mail']['size'] = 25;
      $this->default['nick']['maxlenght'] = 16;
      $this->default['nick']['size'] = 25;
      $this->default['dropdown']['size'] = 1;
      $this->default['number']['size'] = 25;
      $this->default['number']['maxlenght'] = 8; // 8 = ICQ number lenght
      $this->default['url']['maxlenght'] = 255;
      $this->default['url']['size'] = 25;
      $this->default['notes']['rows'] = 4;
      $this->default['notes']['cols'] = 25;
      $this->default['name']['size'] = 25;
      $this->default['name']['maxlenght'] = 60;
      $this->default['file']['type'][0] = 'jpg';
      $this->default['file']['type'][1] = 'gif';
      $this->default['file']['type'][2] = 'png';
      $this->default['file']['size'] = 25;
      $this->default['file']['maxfilesize'] = 50000;
      $this->default['file']['maxheight'] = 64;
      $this->default['file']['maxwidth'] = 64;
      $this->default['file']['allowedtypes'] = 'image/gif;image/jpg;image/jpeg;image/png'; // Delimited by ;
      $this->default['file']['default'] = $CONF['IndexURL'] . 'media/default.jpg';
      $this->default['password']['maxlenght'] = 10;
      $this->default['password']['size'] = 25;
      $this->default['date']['format'] = 'D-M-Y';   
            
      $this->field[0]['name'] = 'msn';
      $this->field[0]['type'] = 'text';
/*
      $this->field[0]['name'] = 'msn';
      $this->field[0]['type'] = 'mail';
*/
      $this->field[1]['name'] = 'sex';
      $this->field[1]['type'] = 'dropdown';
      $this->field[1]['size'] = 2;
      $this->field[1]['option'][0]['name'] = 'male';
      $this->field[1]['option'][0]['value'] = 'm';
      $this->field[1]['option'][1]['name'] = 'female';
      $this->field[1]['option'][1]['value'] = 'f';
      
      $this->field[2]['name'] = 'birthdate';
      $this->field[2]['type'] = 'date';
         
      $this->field[3]['name'] = 'avatar';
      $this->field[3]['type'] = 'file';
      
      $this->field[4]['name'] = 'location';
      $this->field[4]['type'] = 'text';
      
      $this->field[5]['name'] = 'hobbies';
      $this->field[5]['type'] = 'text';
/*
      $this->field[5]['name'] = 'hobbies';
      $this->field[5]['type'] = 'textarea';
      $this->field[5]['cols'] = 60;
 */     
      $this->field[6]['name'] = 'secret';
      $this->field[6]['type'] = 'password';
      
      $this->field[7]['name'] = 'icq';
      $this->field[7]['type'] = 'number';
      
      $this->field[8]['name'] = 'favoritesite';
      $this->field[8]['type'] = 'url';
            
      $this->field[9]['name'] = 'bio';
      $this->field[9]['type'] = 'text';

      $this->field[10]['name'] = 'resume';
      $this->field[10]['type'] = 'url';
   }
   
   function doSkinVar($skinType,$param1,$param2='') {
      global $_GET, $CONF, $memberid, $membername, $member;
      
      if ($skinType == 'member') {
         if ($member->id == $memberid) {
            switch($param1) {
               case 'startform':
                  echo '<form enctype="multipart/form-data" name="profileform" action="' . $CONF['IndexURL'] . 'action.php" method="post">' . "\n";
                  break;
               case 'endform':
                  echo '<input type="hidden" name="action" value="plugin" />';
                  echo '<input type="hidden" name="name" value="Profile" />';
                  echo '<input type="hidden" name="type" value="update" />';
                  echo '<input type="hidden" name="memberid" value="' . $member->id . '" />' . "\n";
                  echo '<input type="submit" name="submit" value="Submit" />' . "\n";
                  echo "</form>\n";
                  break;
               case 'mail':
                  $result = sql_query("SELECT memail FROM ".sql_table(member)." WHERE mnumber=" . $member->id);
                  $value = mysql_result($result,'memail');
                  $size = $this->default['mail']['size'];
                  $maxlenght = $this->default['mail']['maxlenght'];
                  echo '<input name="' . $param1 . '" type="text" maxlenght="' . $maxlenght . '" size="' . $size . '" value="' . $value . '"/>' . "\n";
                  break;
               case 'nick':
                  $result = sql_query("SELECT mname FROM ".sql_table(member)." WHERE mnumber=" . $member->id);
                  $value = mysql_result($result,'mname');
                  $size = $this->default['nick']['size'];
                  $maxlenght = $this->default['nick']['maxlenght'];
                  echo '<input name="' . $param1 . '" type="text" maxlenght="' . $maxlenght . '" size="' . $size . '" value="' . $value . '"/>' . "\n";
                  break;
               case 'realname':
                  $result = sql_query("SELECT mrealname FROM ".sql_table(member)." WWHERE mnumber=" . $member->id);
                  $value = mysql_result($result,'mrealname');
                  $size = $this->default['name']['size'];
                  $maxlenght = $this->default['name']['maxlenght'];
                  echo '<input name="' . $param1 . '" type="text" maxlenght="' . $maxlenght . '" size="' . $size . '" value="' . $value . '"/>' . "\n";
                  break;                  
               case 'url':
                  $result = sql_query("SELECT murl FROM ".sql_table(member)." WHERE mnumber=" . $member->id);
                  $value = mysql_result($result,'murl');
                  $size = $this->default['url']['size'];
                  $maxlenght = $this->default['url']['maxlenght'];
                  echo '<input name="' . $param1 . '" type="text" maxlenght="' . $maxlenght . '" size="' . $size . '" value="' . $value . '"/>' . "\n";
                  break;                  
               case 'notes':
                  $result = sql_query("SELECT mnotes FROM ".sql_table(member)." WHERE mnumber=" . $member->id);
                  $value = mysql_result($result,'mnotes');
                  $rows = $this->default['notes']['rows'];
                  $cols = $this->default['notes']['cols'];
                  echo '<textarea name="' . $param1 . '" cols="' . $cols . '" rows="' . $rows . '">' . $value . '</textarea>' . "\n";
                  break;
               case 'password':
                  $size = $this->default['password']['size'];
                  $maxlenght = $this->default['password']['maxlenght'];                  
                  echo '<input name="' . $param1 . '" type="password" maxlenght="' . $maxlenght . '" size="' . $size . '" />' . "\n";
                  break;
               case 'status':
                  if ($_GET['status'] == 1) {
                     echo 'Profile updated';
                  }
                  break;
               default:
                  $type = $this->getFieldAttribute($param1,'type');
                  switch($type) {
                     case 'text':
                        $value = $this->getValue($member->id,$param1);
                        $maxlenght = $this->getFieldAttribute($param1,'maxlenght');
                        $size = $this->getFieldAttribute($param1,'size');
                        echo '<input name="' . $param1 . '" type="text" maxlenght="' . $maxlenght . '" size="' . $size . '" value="' . $value . '"/>' . "\n";
                        break;
                     case 'number':
                        $value = $this->getValue($member->id,$param1);
                        $maxlenght = $this->getFieldAttribute($param1,'maxlenght');
                        $size = $this->getFieldAttribute($param1,'size');
                        echo '<input name="' . $param1 . '" type="text" maxlenght="' . $maxlenght . '" size="' . $size . '" value="' . $value . '"/>' . "\n";
                        break;
                     case 'url':
                        $value = $this->getValue($member->id,$param1);
                        $maxlenght = $this->getFieldAttribute($param1,'maxlenght');
                        $size = $this->getFieldAttribute($param1,'size');
                        echo '<input name="' . $param1 . '" type="text" maxlenght="' . $maxlenght . '" size="' . $size . '" value="' . $value . '"/>' . "\n";
                        break;                                                                  
                     case 'textarea':
                        $value = $this->getValue($member->id,$param1);
                        $cols = $this->getFieldAttribute($param1,'cols');
                        $rows = $this->getFieldAttribute($param1,'rows');
                        echo '<textarea name="' . $param1 . '" cols="' . $cols . '" rows="' . $rows . '">' . $value . '</textarea>' . "\n";
                        break;
                     case 'mail':
                        $value = $this->getValue($member->id,$param1);
                        $maxlenght = $this->getFieldAttribute($param1,'maxlenght');
                        $size = $this->getFieldAttribute($param1,'size');
                        echo '<input name="' . $param1 . '" type="text" maxlenght="' . $maxlenght . '" size="' . $size . '" value="' . $value . '"/>' . "\n";
                        break;
                     case 'file':
                        $value = $this->getValue($member->id,$param1);
                        $size = $this->getFieldAttribute($param1,'size');
                        if ($param2 != 'show') {
                           echo '<input name="' . $param1 . '" type="file" size="' . $size . '" />' . "\n";
                        } else {
                            if ($value) {
                              echo $CONF['IndexURL'] . '/uploads/' . $value . "\n";
                           } else {
                               echo  $this->default['file']['default']  . "\n";
                           }
                        }
                        break;
                     case 'password':
                        $maxlenght = $this->getFieldAttribute($param1,'maxlenght');
                        $size = $this->getFieldAttribute($param1,'size');
                        echo '<input name="' . $param1 . '" type="password" maxlenght="' . $maxlenght . '" size="' . $size . '" />' . "\n";                                       
                        break;
                     case 'dropdown':
                        $value = $this->getValue($member->id,$param1);
                        $size = $this->getFieldAttribute($param1,'size');
                        if ($size) {
                           echo '<select name="' . $param1 . '" size="' . $size . '">' . "\n";
                        } else {
                           echo '<select name="' . $param1 . '">' . "\n";
                        }
                        $fieldid = $this->getFieldId($param1);
                        for ($i=0;$i < count($this->field[$fieldid]['option']);$i++) {
                           if ($this->field[$fieldid]['option'][$i]['value'] == $value) {
                              echo '<option value="' . $value . '" selected="selected">' . $this->field[$fieldid]['option'][$i]['name'] . '</option>' . "\n";
                           } else {
                              echo '<option value="' . $this->field[$fieldid]['option'][$i]['value'] . '">' . $this->field[$fieldid]['option'][$i]['name'] . '</option>' . "\n";
                           }
                        }
                        echo '</select>' . "\n";
                        break;                     
                     case 'date':
                        $format = $this->getFieldAttribute($param1,'format');
                        $date = $this->getValue($memberid,$param1);
                        $day = substr($date,0,2);
                        $month = substr($date,2,2);
                        $year = substr($date,4,4);
                        switch($format) {
                           case 'D-M-Y':
                              $value = "$day-$month-$year";
                              break;
                           case 'M-D-Y':
                              $value = "$month-$day-$year";
                              break;
                           case 'Y-M-D':
                              $value = "$year-$month-$day";
                              break;
                           case 'Y-D-M':
                              $value = "$year-$day-$month";
                           break;
                        }
                        echo '<input name="' . $param1 . '" type="text" maxlenght="10" size="10" value="' . $value . '"/>' . "\n";
                        break;
                  }         
            }
         } else {
            switch($param1) {
               case 'mail':
                  $result = sql_query("SELECT memail FROM ".sql_table(member)." WHERE mnumber=" . $memberid);
                  $value = mysql_result($result,'memail');
                  echo $this->safeAddress($value);
                  break;
               case 'nick':
                  $result = sql_query("SELECT mname FROM ".sql_table(member)." WHERE mnumber=" . $memberid);
                  $value = mysql_result($result,'mname');
                  echo $value;
                  break;
               case 'realname':
                  $result = sql_query("SELECT mrealname FROM ".sql_table(member)." WHERE mnumber=" . $memberid);
                  $value = mysql_result($result,'mrealname');
                  echo $value;
                  break;                  
               case 'url':
                  $result = sql_query("SELECT murl FROM ".sql_table(member)."  WHERE mnumber=" . $memberid);
                  $value = mysql_result($result,'murl');
                  echo "<a href=\"$value\">$value</a>";
                  break;                  
               case 'notes':
                  $result = sql_query("SELECT mnotes FROM ".sql_table(member)."  WHERE mnumber=" . $memberid);
                  $value = mysql_result($result,'mnotes');
                  $rows = $this->default['notes']['rows'];
                  $cols = $this->default['notes']['cols'];
                  echo '<textarea readonly="readonly" name="' . $param1 . '" cols="' . $cols . '" rows="' . $rows . '">' . $value . '</textarea>' . "\n";
                  break;
               case 'password':
                  echo '********';
                  break;   
               default:
                  $type = $this->getFieldAttribute($param1,'type');
                  switch($type) {
                     case 'text':
                        echo $this->getValue($memberid,$param1);
                        break;
                     case 'url':
                        echo '<a href="' . $this->getValue($memberid,$param1) . '">' . $this->getValue($memberid,$param1) . '</a>' ;
                        break;                        
                     case 'number':   
                        echo $this->getValue($memberid,$param1);
                        break;
                     case 'mail':
                        echo $this->safeAddress($this->getValue($memberid,$param1));
                        break;
                     case 'dropdown':
                        $value = $this->getValue($memberid,$param1);
                        $fieldid = $this->getFieldId($param1);
                        for ($i=0;$i < count($this->field[$fieldid]['option']);$i++) {
                           if ($this->field[$fieldid]['option'][$i]['value'] == $value) {
                              echo $this->field[$fieldid]['option'][$i]['name'] . "\n";
                           }
                        }
                        break;
                     case 'date':
                        $format = $this->getFieldAttribute($param1,'format');
                        $date = $this->getValue($memberid,$param1);
                        $day = substr($date,0,2);
                        $month = substr($date,2,2);
                        $year = substr($date,4,4);
                        switch($format) {
                           case 'D-M-Y':
                              echo "$day-$month-$year";
                           break;
                        case 'M-D-Y':
                           echo "$month-$day-$year";
                           break;
                        case 'Y-M-D':
                           echo "$year-$month-$day";
                           break;
                        case 'Y-D-M':
                           echo "$year-$day-$month";
                           break;
                     }
                     break;
                  case 'textarea':
                     $value = $this->getValue($memberid,$param1);
                     $cols = $this->getFieldAttribute($param1,'cols');
                     $rows = $this->getFieldAttribute($param1,'rows');
                     echo '<textarea readonly="readonly" cols="' . $cols . '" rows="' . $rows . '">' . $value . '</textarea>' . "\n";
                     break;
                  case 'file':
                     if ($param2 == 'show') {
                        $value = $this->getValue($memberid,$param1);
                        if ($value) {
                           echo $CONF['IndexURL'] . '/uploads/' . $value . "\n";
                        } else {
                            echo  $this->default['file']['default']  . "\n";
                        }                     
                     } else {
                        echo 'Only available to the owner of this profile.';
                     }
                     break;
                  case 'password':
                     echo '********';
                     break;
                  }               
               }
            }
      }
   }
   
   function doAction($actionType) {
      global $CONF, $_POST, $_FILES, $member, $DIR_MEDIA, $HTTP_REFERER;
      $key = array_keys($_POST);
         
      // Check if the POST is done by the right member
      if ($member->id == $_POST['memberid']) {
         $memberid = $member->id;
         
         // Loop through all POST vars
         for ($i=0;$i<count($key);$i++) {
            
            // Process all vars except action, type, name, submit, memberid
            if (($key[$i] != 'action') && ($key[$i] != 'type') && ($key[$i] != 'name') && ($key[$i] != 'submit') && ($key[$i] != 'memberid')) {
               $field = $key[$i];
               $value = $_POST[$key[$i]];
               
               // First the 'special', not user-made fields
               switch($field) {
                  case 'nick':
                     if ($value != $member->displayname) {
                        if (!isValidDisplayName($value)) {

                              doError(_ERROR_BADNAME);
                        } else if (MEMBER::exists($value)) {

                           doError(_ERROR_NICKNAMEINUSE);
                        } else {   
                           $member->setDisplayName($value);
                           $member->write();
                        }
                     }
                     break;
                  case 'mail':
                     if ($value != $member->email) {
                        if (!isValidMailAddress($value)) {

                           doError(_ERROR_BADMAILADDRESS);
                        } else {
                           $member->setEmail($value);
                           $member->write();
                        }
                     }
                     break;
                  case 'realname':
                     if ($value != $member->realname) {
                        $value = addslashes($value);
                        $member->setRealName($value);
                        $member->write();   
                     }
                     break;
                  case 'url':
                     if ($value != $member->url) {
                        if (($this->validUrl($value)) || ($value == '')) {
                           $member->setURL($value);
                           $member->write();
                        } else {
                           doError("Not a valid URL");
                        }
                     }
                     break;
                  case 'notes':
                     if ($value != $this->notes) {
                        $member->setNotes($value);
                        $member->write();
                     }
                     break;
                  case 'password':
                     if ($password != '') {
                        $member->setPassword($value);
                        $member->write();
                     }
                     break;
               }
               // Oops, we didn't find a thing :| Time to look for the right type:
               
               $type = $this->getFieldAttribute($field,'type');
               $value = addslashes($value);
               $value = strip_tags($value);
               
               switch($type) {
                  case 'text':
                      $value = substr($value,0,$this->getFieldAttribute($field,'maxlenght'));
                      if(mysql_num_rows(sql_query("SELECT * FROM ".sql_table(plugin_profile)." WHERE memberid=$memberid AND field='$field'")) > 0) {
                         sql_query("UPDATE ".sql_table(plugin_profile)." SET value='$value' WHERE field='$field' AND memberid=$memberid");
                      } else {
                        sql_query("INSERT INTO ".sql_table(plugin_profile)." VALUES($memberid,'$field','$value')");
                      }
                      break;
                  case 'number':
                      $value = substr($value,0,$this->getFieldAttribute($field,'maxlenght'));
                      if (is_numeric($value)) {
                         if(mysql_num_rows(sql_query("SELECT * FROM ".sql_table(plugin_profile)." WHERE memberid=$memberid AND field='$field'")) > 0) {
                            sql_query("UPDATE ".sql_table(plugin_profile)." SET value='$value' WHERE field='$field' AND memberid=$memberid");
                         } else {
                           sql_query("INSERT INTO
			   ".sql_table(plugin_profile)." VALUES($memberid,'$field','$value')");
                         }
                      } else {
                         doError("Not a number.");
                      }               
                     break;
                  case 'url':
                      $value = substr($value,0,$this->getFieldAttribute($field,'maxlenght'));
                      if ($this->validUrl($value) || $value == '') {
                         if(mysql_num_rows(sql_query("SELECT * FROM ".sql_table(plugin_profile)." WHERE memberid=$memberid AND field='$field'")) > 0) {
                            sql_query("UPDATE ".sql_table(plugin_profile)." SET value='$value' WHERE field='$field' AND memberid=$memberid");
                         } else {
                           sql_query("INSERT INTO ".sql_table(plugin_profile)." VALUES($memberid,'$field','$value')");
                         }
                      } else {
                         doError("Not a valid URL.");
                      }               
                     break;                     
                  case 'textarea':
                      if(mysql_num_rows(sql_query("SELECT * FROM ".sql_table(plugin_profile)." WHERE memberid=$memberid AND field='$field'")) > 0) {
                         sql_query("UPDATE ".sql_table(plugin_profile)." SET value='$value' WHERE field='$field' AND memberid=$memberid");
                      } else {
                         sql_query("INSERT INTO ".sql_table(plugin_profile)." VALUES($memberid,'$field','$value')");
                      }
                      break;
                  case 'mail':
                     if (preg_match("/^([a-zA-Z0-9])+([.a-zA-Z0-9_-])*@([a-zA-Z0-9_-])+(.[a-zA-Z0-9_-]+)+[a-zA-Z0-9_-]$/",$value) ){
                        if(mysql_num_rows(sql_query("SELECT * FROM ".sql_table(plugin_profile)." WHERE memberid=$memberid AND field='$field'")) > 0) {
                           sql_query("UPDATE ".sql_table(plugin_profile) ." SET value='$value' WHERE field='$field' AND memberid=$memberid");
                        } else {
                           sql_query("INSERT INTO ".sql_table(plugin_profile)." VALUES($memberid,'$field','$value')");
                        }
                     } else {
                        doError("Not a valid mail adress");
                     }
                     break;                                                   
                  case 'password':
                     $value = substr($value,0,$this->getFieldAttribute($field,'maxlenght'));
                     if ($value != '') {
                        if(mysql_num_rows(sql_query("SELECT * FROM
			".sql_table(plugin_profile)." WHERE memberid=$memberid AND field='$field'")) > 0) {
                           sql_query("UPDATE ".sql_table(plugin_profile)." SET value='$value' WHERE field='$field' AND memberid=$memberid");
                        } else {
                           sql_query("INSERT INTO ".sql_table(plugin_profile)." VALUES($memberid,'$field','$value')");
                        }
                     }
                     break;
                    case 'dropdown':
                     if(mysql_num_rows(sql_query("SELECT * FROM ".sql_table(plugin_profile)." WHERE memberid=$memberid AND field='$field'")) > 0) {
                        sql_query("UPDATE ".sql_table(plugin_profile)." SET value='$value' WHERE field='$field' AND memberid=$memberid");
                     } else {
                        sql_query("INSERT INTO ".sql_table(plugin_profile)." VALUES($memberid,'$field','$value')");
                     }
                     break;
                  case 'date':
                     $format = $this->getFieldAttribute($field,'format');
                     $value = str_replace('-','',$value);
                     switch($format) {
                        case 'D-M-Y':
                           $day = substr($value,0,2);
                           $month = substr($value,2,2);
                           $year = substr($value,4,4);
                           break;
                         case 'M-D-Y':
                           $month = substr($value,0,2);
                           $day = substr($value,2,2);
                           $year = substr($value,4,4);
                           break;
                         case 'Y-M-D':
                           $year = substr($value,0,4);
                           $month = substr($value,4,2);
                           $day = substr($value,5,2);
                           break;
                         case 'Y-D-M':
                           $year = substr($value,0,4);
                           $day = substr($value,4,2);
                           $month = substr($value,6,2);
                           break;
                     }
                           
                     if (($year > 1850) && ($year <= date("Y")) && ($month > 0) && ($month < 13) && ($day > 0) && ($day < 32)) {
                        if(mysql_num_rows(sql_query("SELECT * FROM ".sql_table(plugin_profile)." WHERE memberid=$memberid AND field='$field'")) > 0) {
                           sql_query("UPDATE ".sql_table(plugin_profile)." SET value='" . $day . $month . $year . "' WHERE field='$field' AND memberid=$memberid");
                        } else {
                           sql_query("INSERT INTO ".sql_table(plugin_profile)." VALUES($memberid,'$field','" . $day . $month . $year . "')");
                        }           
                       } else {
                        doError("Wrong date format. Dates have to be in the $format format where day is 2 digits, month is 2 digits and year is 4 digits");                                                           
                       }
                       break;                                       
               } // End innerswitch            
            }
         }
      }
      
      // Now, let's handle the (possible) file uploads
      $file = array_keys($_FILES);
      
      for($i=0;$i<count($file);$i++) {
         $field = $file[$i];
         $filesize = $_FILES[$field]['size'];
         $type = $_FILES[$field]['type'];
         $name = $_FILES[$field]['name'];
         $tmp_name = $_FILES[$field]['tmp_name'];
         $name = addslashes($name);
         
         //Check size
         if ($filesize > $this->getFieldAttribute($field,'maxfilesize')) {
            doError("File is too big. Maximum filesize is " . $this->getFieldAttribute($field,'maxfilesize')/1024 . ' kB');
         }
         
         // Check Type   
         $allowed_types = explode(';',$this->getFieldAttribute($field,'allowedtypes'));
         $sw_allowed = 0;
         
         for($j=0;$j<count($allowed_types);$j++) {
            if ($type == $allowed_types[$j]) {
               $sw_allowed = 1;
            }
         }
         
         if ($sw_allowed != 1) {
            $allowed_types = $this->getFieldAttribute($field,'allowedtypes');
            $allowed_types = str_replace($allowed_types,';',' ');
            doError("File type is not allowed. Must be any of these: $allowed_types");
         }    
         
         // Check size if upload is an image
         
         if ($type == 'image/gif' || $type == 'image/jpg' || $type == 'image/jpeg' || $type == 'image/png') {
            $size = getimagesize($tmp_name);
            $width = $size[0];
            $height = $size[1];
            $maxwidth = $this->getFieldAttribute($field,'maxwidth');
            $maxheight = $this->getFieldAttribute($field,'maxheight');
            if ($maxwidth < $width || $maxheight < $height) {
               doError("Image can have a maximum size of $maxwidth * $maxheight pixels. The one submited by you is $width * $height pixels.");
            }   
         }
         
         // Copy the file
         $extention = $this->showExtention($name);
         $newname = $member->id . '.' .  $field . $extention;
         copy ($tmp_name, "uploads/".$newname) or doError("Could not copy file");    
         
         // Add file location to db
         if(mysql_num_rows(sql_query("SELECT * FROM ".sql_table(plugin_profile)." WHERE memberid=$memberid AND field='$field'")) > 0) {
            sql_query("UPDATE ".sql_table(plugin_profile)." SET value='$newname' WHERE field='$field' AND memberid=$memberid");
         } else {
            sql_query("INSERT INTO ".sql_table(plugin_profile)." VALUES($memberid,'$field','$newname')");
         }      
      }
      
         
         
      
      header("Location:" . $HTTP_REFERER . "index.php?memberid=" . $memberid);
   }
   
   function getTableList() {   return array(sql_table(plugin_profile)); }
   
   function getValue($memberid, $field) {
      $result = sql_query("SELECT value FROM ".sql_table(plugin_profile)." WHERE memberid=$memberid AND field='$field'");
      
      if (mysql_num_rows($result) > 0) {
         return mysql_result($result,'value');
      } else {
         return null;
      }
   }
   
   function getFieldId($field) {
      for ($i=0; $i <= count($this->field);$i++) {
         if (($this->field[$i]['name'] == $field)) {
            return $i;
         }      
      }
   }   
   
   function getFieldAttribute($field,$attribute) {
      for ($i=0; $i <= count($this->field);$i++) {
         if (($this->field[$i]['name'] == $field)) {
            $result = $this->field[$i][$attribute];
         }      
      }
      
      if ($result == '') {
         for ($i=0; $i <= count($this->field);$i++) {
            if ($this->field[$i]['name'] == $field) {
               $type = $this->field[$i]['type'];
            }         
            $result = $this->default[$type][$attribute];
         }      
      }
      
      return $result;   
   }
   
   function safeAddress($emailAddress, $theTitle='Mail user', $xhtml=1, $isItSafe=0) {
      // Version 1.5 - by Dan Benjamin - http://www.hivelogic.com/
      // set $isItSafe = 1 to get escaped HTML, 0 for normal HTML
      // set $xhtml = 1 if you want your page to be valid for XHTML 1.x
      // Modified by Tim Broddin to better suit his needs

       $ent = "";
       $userName = "";
       $domainName = "";
   
       for ($i = 0; $i < strlen($emailAddress); $i++) {
           $c = substr($emailAddress, $i, 1);
           if ($c == "@") {
               $userName = $ent;
               $ent = "";
            } else {
               $ent .= "&#" . ord($c) . ";";
            }
       }   

       $domainName = $ent;
   
       if ($xhtml == 1) {
          $endResult = "<a href=\"mailto:$userName@$domainName\" title=\"$theTitle\">$userName@$domainName</a>";
       } else {
           $endResult = "<a href=\"mailto:$userName@$domainName\" title=\"$theTitle\">$userName@$domainName</a>";
        }
       if ($isItSafe) {
           return(htmlentities($endResult));
       } else {
           return($endResult);
       }
   }
   
   function validUrl($url) {
      if (substr($url,0,7) == 'http://') {
         return true;
      }
   }
   
   function showExtention($filename) {
      // By Cristoph2k http://www.evilwalrus.com/viewcode.php?codeEx=496
       $ext = explode(".", $filename);
       $extention = "";
       for($i=1;$i<=sizeof($ext)-1;$i++) {
           if($ext) {
               $extention .= ".".$ext[$i];
           }
       }
       return $extention;
   }
}
?>
